# Changelog
This file contains highlights of what changes on each version of the [Node.js Interop for Dart](https://github.com/cedx/nodejs-interop.dart) library.

## Version [0.8.0](https://github.com/cedx/nodejs-interop.dart/compare/v0.7.0...v0.8.0)
- Breaking change: removed most classes of the `nodejs_interop.js` library (`JSObject`, `Json`, `Reflect`, `TypedArray` and `Uint8Array`).
- Breaking change: removed the instance methods of the `Buffer` class, as this class is casted to the `Uint8List` class by the Dart runtime.
- Breaking change: renamed the `convertToFuture()` function to `asFuture()`.
- Breaking change: renamed the `convertToStream()` function to `asStream()`.
- Breaking change: renamed the `DeleteOptions` class to `DelOptions`.
- Breaking change: renamed the `NodeProcess` class to `Process`.
- Breaking change: renamed the `NodeRelease` class to `Release`.
- Breaking change: renamed the `ReadStream` class to `FSReadStream`.
- Breaking change: renamed the `WriteStream` class to `FSWriteStream`.
- Breaking change: the `FileStat.fromStats()` constructor is now private.
- Added the [`tty`](https://nodejs.org/api/tty.html) module.
- Added utility functions for converting functions following the [Node.js](https://nodejs.org) callback style to a `Future` (e.g. `fn1cb0ToFuture()`, `fn3cb2ToFuture()`, ...).
- Added the `RandomAccessFile` and `SystemEncoding` classes.
- Added the `asPromise()`, `deleteProperty()` and `getProperties()` functions.
- Added the `Promise.JS$catch()` method.
- Added new unit tests.
- Fixed the implementation of the `FileStat` class.
- The `nodejs_interop.js` library exports the functions from the `dart:js_util` library.
- Updated the [Node.js](https://nodejs.org) dependencies.

## Version [0.7.0](https://github.com/cedx/nodejs-interop.dart/compare/v0.6.0...v0.7.0)
- Breaking change: renamed the `convertToDart()` function to `dartify()`.
- Breaking change: renamed the `ReaddirEnhancedModule` class to `ReaddirModule`.
- Breaking change: the `nodejs_interop.io`, `nodejs_interop.js`, `nodejs_interop.node` and `nodejs_interop.npm` libraries are no longer exported individually.
- Added the `exit()` and `sleep()` functions.
- Added the `exitCode` and `pid` properties.
- Added the `Buffer.BYTES_PER_ELEMENT` static property.
- Added the `InternetAddress`, `InternetAddressType`, `JSObject`, `NetworkInterface`, `ProcessInfo` and `Reflect` classes.
- Added the `minify` option to the [Pub](https://pub.dartlang.org) transformer.
- Added new methods to the `Console` and `Uint8Array` classes.
- Added new unit tests.
- Fixed the implementation of the [`dns`](https://nodejs.org/api/dns.html) module.

## Version [0.6.0](https://github.com/cedx/nodejs-interop.dart/compare/v0.5.0...v0.6.0)
- Breaking change: renamed the `Path` class to `PathObject`.
- Breaking change: renamed the `ReadOptions` class to `ReadFileOptions`.
- Breaking change: renamed the `ResolveOptions` class to `ResolveFunctionOptions`.
- Breaking change: renamed the `WarningOptions` class to `EmitWarningOptions`.
- Breaking change: renamed the `WriteOptions` class to `WriteFileOptions`.
- Added setters to properties of all `@anonymous` classes.
- Added the [`dns`](https://nodejs.org/api/dns.html) module.
- Added the [`querystring`](https://nodejs.org/api/querystring.html) module.
- Added the [`string_decoder`](https://nodejs.org/api/string_decoder.html) module.
- Added the [`url`](https://nodejs.org/api/url.html) module.
- Added a partial implementation of the [process manager API](https://pub.dartlang.org/packages/process).
- Added a [Pub](https://pub.dartlang.org) transformer.
- Finished the implementation of the [`util`](https://nodejs.org/api/util.html) module.

## Version [0.5.0](https://github.com/cedx/nodejs-interop.dart/compare/v0.4.0...v0.5.0)
- Breaking change: removed the `FileStat.toJson()` method.
- Breaking change: renamed the `Process` class to `NodeProcess`.
- Added the [`child_process`](https://nodejs.org/api/child_process.html) module.
- Added the [`cluster`](https://nodejs.org/api/cluster.html) module.
- Added the [`stream`](https://nodejs.org/api/stream.html) module.
- Added the [`vm`](https://nodejs.org/api/vm.html) module.
- Added the `BufferEncoding.fromEncoding()` method.
- Added the `current` and `systemTemp` static properties to the `Directory` class.
- Finished the implementation of the [`fs`](https://nodejs.org/api/fs.html) module.

## Version [0.4.0](https://github.com/cedx/nodejs-interop.dart/compare/v0.3.0...v0.4.0)
- Breaking change: renamed the `Js` prefix to `JS` for JavaScript errors.
- Breaking change: renamed the `NodejsPlatform` class to `Platform`.
- Added bindings for a predefined set of [npm](https://www.npmjs.com) packages.
- Added the [`buffer`](https://nodejs.org/api/buffer.html) module.
- Added the [`console`](https://nodejs.org/api/console.html) module.
- Added the `convertToStream()` and `loadLibrary()` functions.
- Added the `Json`, `Module` and `Writable` classes.
- Added a partial implementation of the [`fs`](https://nodejs.org/api/fs.html) module.
- Added a partial implementation of the [`util`](https://nodejs.org/api/util.html) module.
- Added a partial implementation of the [file system API](https://pub.dartlang.org/packages/file).
- Finished the implementation of the `Process` class.
- Finished the implementation of the `require()` function.
- Splitted the library in modules: `io`, `js`, `node` and `npm`.

## Version [0.3.0](https://github.com/cedx/nodejs-interop.dart/compare/v0.2.0...v0.3.0)
- Added the [`os`](https://nodejs.org/api/os.html) module.
- Added the `convertToDart()` and `convertToFuture()` functions.
- Added the `CpuUsage`, `NodejsPlatform` and `Promise` classes.
- Added a partial implementation of the `Process` class.

## Version [0.2.0](https://github.com/cedx/nodejs-interop.dart/compare/v0.1.0...v0.2.0)
- Breaking change: renamed the `PathObject` class to `Path`.
- Added the [`assert`](https://nodejs.org/api/assert.html) module.
- Added the [`errors`](https://nodejs.org/api/errors.html) module.
- Added the [`events`](https://nodejs.org/api/events.html) module.

## Version 0.1.0
- Initial release: provides the `require()` function and the [`path`](https://nodejs.org/api/path.html) module.
