part of nodejs_interop.io;

/// The current system encoding. Always UTF-8 on Node.js platform.
const SystemEncoding SYSTEM_ENCODING = const SystemEncoding(); // ignore: constant_identifier_names

/// The system encoding is always UTF-8 on Node.js platform.
class SystemEncoding extends Encoding {

  /// Creates a new system encoding.
  const SystemEncoding();

  /// The decoder of this encoding.
  @override
  Converter<List<int>, String> get decoder => UTF8.decoder;

  /// The encoder of this encoding.
  @override
  Converter<String, List<int>> get encoder => UTF8.encoder;

  /// Name of the encoding.
  @override
  String get name => 'system';

  /// Returns a string representation of this object.
  @override
  String toString() => 'SystemEncoding("${UTF8.name}")';
}
