part of nodejs_interop.node;

/// Defines the type of a DNS resource record.
abstract class ResourceRecordType {

  /// An IPv4 address.
  static const String a = 'A';

  /// An IPv6 address.
  static const String aaaa = 'AAAA';

  /// Any record.
  static const String any = 'ANY';

  /// A canonical name record.
  static const String cname = 'CNAME';

  /// A mail exchange record.
  static const String mx = 'MX';

  /// A name authority pointer record.
  static const String naptr = 'NAPTR';

  /// A name server record.
  static const String ns = 'NS';

  /// A pointer record.
  static const String ptr = 'PTR';

  /// A start of authority record.
  static const String soa = 'SOA';

  /// A service record.
  static const String srv = 'SRV';

  /// A text record.
  static const String txt = 'TXT';
}
