part of nodejs_interop.node;

/// A [Readable] file stream returned by the [FSModule.createReadStream] method.
@JS()
abstract class FSReadStream<T> extends Readable<T> {

  /// The number of bytes read so far.
  external int get bytesRead;

  /// The path to the file the stream is reading from.
  external dynamic get path;
}

/// A [Writable] file stream returned by the [FSModule.createWriteStream] method.
@JS()
abstract class FSWriteStream<T> extends Writable<T> {

  /// The number of bytes written so far.
  external int get bytesWritten;

  /// The path to the file the stream is reading from.
  external dynamic get path;
}
