part of nodejs_interop.node;

/// A TCP or IPC server.
@JS(r'$net.Server')
class NetServer extends EventEmitter {

  /// Creates a new TCP or IPC server.
  external NetServer([ServerOptions options, void connectionListener(Socket socket)]);

  /// Returns the bound address, the address family name and port of the server as reported by the operating system.
  external SocketAddress address();

  /// Stops the server from accepting new connections and keeps existing connections.
  ///
  /// The optional [callback] will be called once the `close` event occurs.
  /// Unlike that event, it will be called with a [JSError] as its only argument if the server was not open when it was closed.
  external NetServer close([CompletionCallback0 callback]);

  /// TODO
  external NetServer getConnections();
}

/// Options used to customize the creation of a [NetServer].
@JS()
@anonymous
class ServerOptions {

  /// Creates a new options object.
  external factory ServerOptions();
}
