part of nodejs_interop.node;

/// Information about a CPU core.
@JS()
abstract class Cpu {

  /// The number of milliseconds the CPU has spent in idle mode.
  external String get model;

  /// The number of milliseconds the CPU has spent in interrupt request mode.
  external int get speed;

  /// The number of milliseconds the CPU has spent in scheduling priority mode.
  external CpuTimes get times;
}

/// The time usage of a CPU core.
@JS()
abstract class CpuTimes {

  /// The number of milliseconds the CPU has spent in idle mode.
  external int get idle;

  /// The number of milliseconds the CPU has spent in interrupt request mode.
  external int get irq;

  /// The number of milliseconds the CPU has spent in scheduling priority mode.
  external int get nice;

  /// The number of milliseconds the CPU has spent in system mode.
  external int get sys;

  /// The number of milliseconds the CPU has spent in user mode.
  external int get user;
}
