part of nodejs_interop.node;

/// Describes a network address assigned to a network interface.
@JS()
abstract class NetworkAddress {

  /// The assigned IPv4 or IPv6 address.
  external String get address;

  /// The assigned IPv4 or IPv6 address with the routing prefix in CIDR notation.
  /// If the [netmask] is invalid, this property is set to `null`.
  external String get cidr;

  /// Either `"IPv4"` or `"IPv6"`.
  external String get family;

  /// Whether the network interface is a loopback or similar interface that is not remotely accessible.
  external bool get internal;

  /// The MAC address of the network interface.
  external String get mac;

  /// The IPv4 or IPv6 network mask.
  external String get netmask;

  /// The numeric IPv6 scope identifier (only specified when [family] is `"IPv6"`).
  external int get scopeid;
}
