part of nodejs_interop.node;

/// Promisifies functions by returning a version that returns [Promise]s.
@JS()
abstract class PromisifyFunction implements Function {

  /// A [`Symbol`](https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Symbol)
  /// that can be used to declare custom `promisify` functions.
  external dynamic get custom;

  /// Takes a [function] following the common Node.js callback style, i.e. taking a `(err, value) => ...` callback as the last argument,
  /// and returns a version that returns [Promise]s.
  external Function call(Function function);
}
