part of nodejs_interop.node;

/// Takes a stream of code points as input and emits a stream of bytes.
/// All instances of [TextEncoder] only support UTF-8 encoding.
@JS(r'$util.TextEncoder')
class TextEncoder {

  /// Creates a new text encoder.
  external TextEncoder();

  /// The encoding supported by this instance. Always set to `"utf-8"`.
  external String get encoding;

  /// Encodes the [input] string and returns a [Uint8List] containing the encoded bytes.
  external Uint8List encode([String input = '']);
}
