/// Support for interoperating with [`os-locale`](https://www.npmjs.com/package/os-locale) package.
@JS()
library nodejs_interop.npm.os_locale;

import 'package:js/js.dart';
import 'package:nodejs_interop/js.dart';

/// The [`os-locale`](https://www.npmjs.com/package/os-locale) module.
@JS()
abstract class OSLocaleModule implements Function {

  /// Gets the name of the current locale. Returns a [Promise] that resolves with the locale name.
  external Promise<String> call([OSLocaleOptions options]);

  /// Synchronously gets the name of the current locale.
  external String sync([OSLocaleOptions options]);
}

/// Options used to customize the locale resolution.
@JS()
@anonymous
class OSLocaleOptions {

  /// Creates a new options object.
  external factory OSLocaleOptions({bool spawn = true});

  /// Value indicating whether to spawn subprocesses for resolving the locale.
  /// Set to `false` to only resolve the locale from environment variables.
  external bool get spawn;
  external set spawn(bool value);
}
