import 'package:nodejs_interop/io.dart';
import 'package:test/test.dart';

/// Tests the features of the [NetworkInterface] class.
void main() => group('NetworkInterface', () {
  group('.list()', () {
    test('should return the list of network interfaces', () async {
      var interfaces = await NetworkInterface.list(includeLoopback: true);
      expect(interfaces, isNotEmpty);

      var loopbackInterface = interfaces.singleWhere((interface) => interface.name == 'lo');
      expect(loopbackInterface.addresses, isNotEmpty);

      var loopbackAddress = loopbackInterface.addresses.singleWhere((address) => address.type == InternetAddressType.IP_V4);
      expect(loopbackAddress.address, equals('127.0.0.1'));
    });
  });

  group('.listSupported', () {
    test('should always be `true` on Node.js platform', () {
      expect(NetworkInterface.listSupported, isTrue);
    });
  });
});
