import 'package:nodejs_interop/js.dart';
import 'package:test/test.dart';

/// Tests the features of the [JSError] classes.
void main() {
  group('JSError', () {
    test('should be an instance of the `Exception` class', () {
      var error = new JSError('An error message');
      expect(error, isException);
      expect(error.message, equals('An error message'));
      expect(error.name, equals('Error'));
    });
  });

  group('JSEvalError', () {
    test('should be an instance of the `Exception` class', () {
      var error = new JSEvalError('An error message');
      expect(error, isException);
      expect(error.message, equals('An error message'));
      expect(error.name, equals('EvalError'));
    });
  });

  group('JSRangeError', () {
    test('should be an instance of the `Exception` class', () {
      var error = new JSRangeError('An error message');
      expect(error, isException);
      expect(error.message, equals('An error message'));
      expect(error.name, equals('RangeError'));
    });
  });

  group('JSReferenceError', () {
    test('should be an instance of the `Exception` class', () {
      var error = new JSReferenceError('An error message');
      expect(error, isException);
      expect(error.message, equals('An error message'));
      expect(error.name, equals('ReferenceError'));
    });
  });

  group('JSSyntaxError', () {
    test('should be an instance of the `Exception` class', () {
      var error = new JSSyntaxError('An error message');
      expect(error, isException);
      expect(error.message, equals('An error message'));
      expect(error.name, equals('SyntaxError'));
    });
  });

  group('JSTypeError', () {
    test('should be an instance of the `Exception` class', () {
      var error = new JSTypeError('An error message');
      expect(error, isException);
      expect(error.message, equals('An error message'));
      expect(error.name, equals('TypeError'));
    });
  });

  group('JSUriError', () {
    test('should be an instance of the `Exception` class', () {
      var error = new JSUriError('An error message');
      expect(error, isException);
      expect(error.message, equals('An error message'));
      expect(error.name, equals('URIError'));
    });
  });
}
