import 'package:nodejs_interop/node.dart';
import 'package:test/test.dart';

/// Tests the features of the [JSAssertionError] class.
void main() => group('JSAssertionError', () {
  loadLibrary<AssertModule>('assert');

  test('should be an instance of the `Exception` class', () {
    var error = new JSAssertionError(new AssertionErrorOptions(actual: 123, message: 'An error message'));
    expect(error, isException);
    expect(error.actual, equals(123));
    expect(error.message, equals('An error message'));
    expect(error.name, equals('AssertionError [ERR_ASSERTION]'));
  });
});
