import 'package:nodejs_interop/node.dart';
import 'package:test/test.dart';

/// Tests the features of the [StringDecoder] class.
void main() => group('StringDecoder', () {
  loadLibrary('string_decoder');

  group('.end()', () {
    test('should return any remaining input stored in the internal buffer as a string', () {
      var decoder = new StringDecoder()..write(Buffer.from([0xE2]))..write(Buffer.from([0x82]));
      expect(decoder.end(Buffer.from([0xAC])), equals('€'));
    });
  });

  group('.write()', () {
    test('should return a decoded string, omitting any incomplete multibyte characters at the end of the buffer', () {
      var decoder = new StringDecoder();
      expect(decoder.write(Buffer.from([0xC2, 0xA2])), equals('¢'));
      expect(decoder.write(Buffer.from([0xE2, 0x82, 0xAC])), equals('€'));
      expect(decoder.write(Buffer.from([0xE2])), isEmpty);
    });
  });
});
