import 'package:nodejs_interop/js.dart';
import 'package:nodejs_interop/node.dart';
import 'package:nodejs_interop/npm.dart';
import 'package:test/test.dart';

/// Tests the features of the `os-locale` package.
void main() => group('OSLocaleModule', () {
  final localeRegex = new RegExp(r'^[a-z]{2,3}_[A-Z]{2,3}$');
  final OSLocaleModule osLocale = require('os-locale');

  group('.call()', () {
    test('should return a locale formatted like "<language>_<REGION>"', () async {
      expect(await asFuture<String>(osLocale()), matches(localeRegex));
      expect(await asFuture<String>(osLocale.call()), matches(localeRegex));
    });
  });

  group('.sync()', () {
    test('should synchronously return a locale formatted like "<language>_<REGION>"', () {
      expect(osLocale.sync(), matches(localeRegex));
    });
  });
});
